commit e362ec12a3a32045cc276e46c01216181edb5cf7
Author: Moritz Bunkus <m.bunkus@linet.de>
Date:   Wed Nov 10 14:40:28 2021 +0100

    Benutzerdef. Var. als HTML-Feld: Verwaltung

diff --git a/locale/de/all b/locale/de/all
index fb0257284..67f877063 100755
--- a/locale/de/all
+++ b/locale/de/all
@@ -1641,6 +1641,7 @@ $self->{texts} = {
   'Groups valid for this client' => 'Für Mandanten gültige Gruppen',
   'HTML'                        => 'HTML',
   'HTML Templates'              => 'HTML-Vorlagen',
+  'HTML field'                  => 'HTML-Feld',
   'Handling of WebDAV'          => 'Behandlung von WebDAV',
   'Hardcopy'                    => 'Seite drucken',
   'Has item type'               => 'Hat Regeltypen',
@@ -3363,10 +3364,10 @@ $self->{texts} = {
   'Text blocks back'            => 'Textblöcke hinten',
   'Text blocks front'           => 'Textblöcke vorne',
   'Text field'                  => 'Textfeld',
-  'Text field variables: \'WIDTH=w HEIGHT=h\' sets the width and height of the text field. They default to 30 and 5 respectively.' => 'Textfelder: \'WIDTH=w HEIGHT=h\' setzen die Breite und die Höhe des Textfeldes. Wenn nicht anders angegeben, so werden sie 30 Zeichen breit und fünf Zeichen hoch dargestellt.',
+  'Text field and HTML field variables: \'WIDTH=w HEIGHT=h\' sets the width and height of the text field. They default to 30 and 5 respectively.' => 'Textfelder und HTML-Felder: \'WIDTH=w HEIGHT=h\' setzen die Breite und die Höhe des Textfeldes. Wenn nicht anders angegeben, so werden sie 30 Zeichen breit und fünf Zeichen hoch dargestellt.',
   'Text in CSV File'            => 'Spalte in der CSV Datei',
   'Text variables: \'MAXLENGTH=n\' sets the maximum entry length to \'n\'.' => 'Textzeilen: \'MAXLENGTH=n\' setzt eine Maximallänge von n Zeichen.',
-  'Text, text field and number variables: The default value will be used as-is.' => 'Textzeilen, Textfelder und Zahlenvariablen: Der Standardwert wird so wie er ist übernommen.',
+  'Text, text field, HTML field and number variables: The default value will be used as-is.' => 'Textzeilen, Textfelder, HTML-Felder und Zahlenvariablen: Der Standardwert wird so wie er ist übernommen.',
   'Texts for invoices'          => 'Texte für Rechnungen',
   'Texts for quotations & orders' => 'Texte für Angebote & Aufträge',
   'That export does not exist.' => 'Dieser Export existiert nicht.',
diff --git a/locale/en/all b/locale/en/all
index 615173f1c..26cee2d0f 100644
--- a/locale/en/all
+++ b/locale/en/all
@@ -1641,6 +1641,7 @@ $self->{texts} = {
   'Groups valid for this client' => '',
   'HTML'                        => '',
   'HTML Templates'              => '',
+  'HTML field'                  => '',
   'Handling of WebDAV'          => '',
   'Hardcopy'                    => '',
   'Has item type'               => '',
@@ -3362,10 +3363,10 @@ $self->{texts} = {
   'Text blocks back'            => '',
   'Text blocks front'           => '',
   'Text field'                  => '',
-  'Text field variables: \'WIDTH=w HEIGHT=h\' sets the width and height of the text field. They default to 30 and 5 respectively.' => '',
+  'Text field and HTML field variables: \'WIDTH=w HEIGHT=h\' sets the width and height of the text field. They default to 30 and 5 respectively.' => '',
   'Text in CSV File'            => '',
   'Text variables: \'MAXLENGTH=n\' sets the maximum entry length to \'n\'.' => '',
-  'Text, text field and number variables: The default value will be used as-is.' => '',
+  'Text, text field, HTML field and number variables: The default value will be used as-is.' => '',
   'Texts for invoices'          => '',
   'Texts for quotations & orders' => '',
   'That export does not exist.' => '',
diff --git a/templates/webpages/custom_variable_config/form.html b/templates/webpages/custom_variable_config/form.html
index a03bcd26e..50355e609 100644
--- a/templates/webpages/custom_variable_config/form.html
+++ b/templates/webpages/custom_variable_config/form.html
@@ -127,7 +127,7 @@
   (4) [% 'The default value depends on the variable type:' | $T8 %]
   <br>
   <ul>
-   <li>[%- 'Text, text field and number variables: The default value will be used as-is.' | $T8 %]</li>
+   <li>[%- 'Text, text field, HTML field and number variables: The default value will be used as-is.' | $T8 %]</li>
    <li>[%- 'Boolean variables: If the default value is non-empty then the checkbox will be checked by default and unchecked otherwise.' | $T8 %]</li>
    <li>[%- 'Date and timestamp variables: If the default value equals \'NOW\' then the current date/current timestamp will be used. Otherwise the default value is copied as-is.' | $T8 %]</li>
   </ul>
@@ -138,7 +138,7 @@
   <br>
   <ul>
    <li>[%- 'Text variables: \'MAXLENGTH=n\' sets the maximum entry length to \'n\'.' | $T8 %]</li>
-   <li>[%- 'Text field variables: \'WIDTH=w HEIGHT=h\' sets the width and height of the text field. They default to 30 and 5 respectively.' | $T8 %]</li>
+   <li>[%- 'Text field and HTML field variables: \'WIDTH=w HEIGHT=h\' sets the width and height of the text field. They default to 30 and 5 respectively.' | $T8 %]</li>
    <li>[%- 'Number variables: \'PRECISION=n\' forces numbers to be shown with exactly n decimal places.' | $T8 %]</li>
    <li>[%- 'Selection fields: The option field must contain the available options for the selection. Options are separated by \'##\', for example \'Early##Normal##Late\'.' | $T8 %]</li>
   </ul>