commit bd383c2fee6c643c438873a856d6cfef6f7bf395
Author: Rolf Fluehmann <rolf.fluehmann@revamp-it.ch>
Date:   Tue Jun 7 11:07:11 2016 +0200

    new settings balance, datev, erfolgsrechnung, eurechnung, ustva to client-features

diff --git a/SL/DB/MetaSetup/Default.pm b/SL/DB/MetaSetup/Default.pm
index 96c4b0f1f..bd02674dd 100644
--- a/SL/DB/MetaSetup/Default.pm
+++ b/SL/DB/MetaSetup/Default.pm
@@ -49,6 +49,11 @@ __PACKAGE__->meta->columns(
   duns                                      => { type => 'text' },
   email_journal                             => { type => 'integer', default => 2 },
   expense_accno_id                          => { type => 'integer' },
+  feature_balance                           => { type => 'boolean', default => 'true', not_null => 1 },
+  feature_datev                             => { type => 'boolean', default => 'true', not_null => 1 },
+  feature_erfolgsrechnung                   => { type => 'boolean', default => 'false', not_null => 1 },
+  feature_eurechnung                        => { type => 'boolean', default => 'true', not_null => 1 },
+  feature_ustva                             => { type => 'boolean', default => 'true', not_null => 1 },
   fxgain_accno_id                           => { type => 'integer' },
   fxloss_accno_id                           => { type => 'integer' },
   gl_changeable                             => { type => 'integer', default => 2, not_null => 1 },
diff --git a/locale/de/all b/locale/de/all
index f34d1b110..3689269c4 100755
--- a/locale/de/all
+++ b/locale/de/all
@@ -3230,6 +3230,11 @@ $self->{texts} = {
   'Uploaded at'                 => 'Hochgeladen um',
   'Uploaded on #1, size #2 kB'  => 'Am #1 hochgeladen, Größe #2 kB',
   'Use As New'                  => 'Als neu verwenden',
+  'Use Balance Sheet'           => 'Bilanz verwenden',
+  'Use Datevautomatik'          => 'Datev-Automatik verwenden',
+  'Use Income'                  => 'Einnahmen-Überschuß-Rechnung verwenden',
+  'Use Erfolgsrechnung'         => 'Erfolgsrechnung verwenden',
+  'Use UStVA'                   => 'UStVA verwenden',
   'Use WebDAV Repository'       => 'WebDAV-Ablage verwenden',
   'Use existing templates'      => 'Vorhandene Druckvorlagen verwenden',
   'Use linked items'            => 'Verknüpfte Positionen verwenden',
diff --git a/sql/Pg-upgrade2/defaults_add_features.sql b/sql/Pg-upgrade2/defaults_add_features.sql
new file mode 100644
index 000000000..897082c52
--- /dev/null
+++ b/sql/Pg-upgrade2/defaults_add_features.sql
@@ -0,0 +1,8 @@
+-- @tag: defaults_add_features
+-- @description: flags to switch on/off the features for the clients
+-- @depends: release_3_3_0
+ALTER TABLE defaults ADD COLUMN feature_balance BOOLEAN NOT NULL DEFAULT TRUE;
+ALTER TABLE defaults ADD COLUMN feature_datev BOOLEAN NOT NULL DEFAULT TRUE;
+ALTER TABLE defaults ADD COLUMN feature_erfolgsrechnung BOOLEAN NOT NULL DEFAULT FALSE;
+ALTER TABLE defaults ADD COLUMN feature_eurechnung BOOLEAN NOT NULL DEFAULT TRUE;
+ALTER TABLE defaults ADD COLUMN feature_ustva BOOLEAN NOT NULL DEFAULT TRUE;
diff --git a/templates/webpages/client_config/_features.html b/templates/webpages/client_config/_features.html
index 0a06d43e0..c95c6e5db 100644
--- a/templates/webpages/client_config/_features.html
+++ b/templates/webpages/client_config/_features.html
@@ -1,6 +1,22 @@
 [%- USE LxERP -%][%- USE L -%][%- USE P -%][%- USE T8 %]
 <div id="features">
  <table>
+  <tr><td class="listheading" colspan="4">[% LxERP.t8("DATEV") %]</td></tr>
+
+  <tr>
+   <td align="right">[% LxERP.t8('Datevautomatik') %]</td>
+   <td>[% L.yes_no_tag('defaults.feature_datev', SELF.defaults.feature_datev) %]</td>
+   <td>[% LxERP.t8('Use Datevautomatik') %]</td>
+  </tr>
+
+  <tr><td class="listheading" colspan="4">[% LxERP.t8("UStVA") %]</td></tr>
+
+  <tr>
+   <td align="right">[% LxERP.t8('UStVA') %]</td>
+   <td>[% L.yes_no_tag('defaults.feature_ustva', SELF.defaults.feature_ustva) %]</td>
+   <td>[% LxERP.t8('Use UStVA') %]</td>
+  </tr>
+
   <tr><td class="listheading" colspan="4">[% LxERP.t8("WebDAV") %]</td></tr>
 
   <tr>
@@ -14,6 +30,24 @@
    <td>[% LxERP.t8('Save document in WebDAV repository') %]</td>
   </tr>
 
+  <tr><td class="listheading" colspan="4">[% LxERP.t8("Reports") %]</td></tr>
+
+  <tr>
+   <td align="right">[% LxERP.t8('Balance') %]</td>
+   <td>[% L.yes_no_tag('defaults.feature_balance', SELF.defaults.feature_balance) %]</td>
+   <td>[% LxERP.t8('Use Balance Sheet') %]</td>
+  </tr>
+  <tr>
+   <td align="right">[% LxERP.t8('income') %]</td>
+   <td>[% L.yes_no_tag('defaults.feature_eurechnung', SELF.defaults.feature_eurechnung) %]</td>
+   <td>[% LxERP.t8('Use Income') %]</td>
+  </tr>
+  <tr>
+   <td align="right">[% LxERP.t8('Erfolgsrechnung') %]</td>
+   <td>[% L.yes_no_tag('defaults.feature_erfolgsrechnung', SELF.defaults.feature_erfolgsrechnung) %]</td>
+   <td>[% LxERP.t8('Use Erfolgsrechnung') %]</td>
+  </tr>
+
   <tr><td class="listheading" colspan="4">[% LxERP.t8("Customer Master Data") %]</td></tr>
 
   <tr>