commit 3efb443e966e61d1812be458f5a7aa6833dcc6c4
Author: Sven Schöling <s.schoeling@googlemail.com>
Date:   Fri Oct 13 15:27:35 2017 +0200

    kivi.Validator: explizites check_right_*_format auf Validator umgestellt

diff --git a/bin/mozilla/ap.pl b/bin/mozilla/ap.pl
index f13b8d251..f2e359802 100644
--- a/bin/mozilla/ap.pl
+++ b/bin/mozilla/ap.pl
@@ -437,7 +437,7 @@ sub form_header {
   my $follow_up_vc         = $form->{vendor_id} ? SL::DB::Vendor->load_cached($form->{vendor_id})->name : '';
   my $follow_up_trans_info =  "$form->{invnumber} ($follow_up_vc)";
 
-  $::request->layout->add_javascripts("autocomplete_chart.js", "show_vc_details.js", "show_history.js", "follow_up.js", "kivi.Draft.js", "kivi.GL.js", "kivi.RecordTemplate.js", "kivi.File.js", "kivi.AP.js", "kivi.CustomerVendor.js");
+  $::request->layout->add_javascripts("autocomplete_chart.js", "show_vc_details.js", "show_history.js", "follow_up.js", "kivi.Draft.js", "kivi.GL.js", "kivi.RecordTemplate.js", "kivi.File.js", "kivi.AP.js", "kivi.CustomerVendor.js", "kivi.Validator.js");
   my $transdate = $::form->{transdate} ? DateTime->from_kivitendo($::form->{transdate}) : DateTime->today_local;
   my $first_taxchart;
 
diff --git a/bin/mozilla/ar.pl b/bin/mozilla/ar.pl
index 089446bda..95bcff526 100644
--- a/bin/mozilla/ar.pl
+++ b/bin/mozilla/ar.pl
@@ -393,7 +393,7 @@ sub form_header {
   my $follow_up_vc         = $form->{customer_id} ? SL::DB::Customer->load_cached($form->{customer_id})->name : '';
   my $follow_up_trans_info =  "$form->{invnumber} ($follow_up_vc)";
 
-  $::request->layout->add_javascripts("autocomplete_chart.js", "show_vc_details.js", "show_history.js", "follow_up.js", "kivi.Draft.js", "kivi.GL.js", "kivi.File.js", "kivi.RecordTemplate.js", "kivi.AR.js", "kivi.CustomerVendor.js");
+  $::request->layout->add_javascripts("autocomplete_chart.js", "show_vc_details.js", "show_history.js", "follow_up.js", "kivi.Draft.js", "kivi.GL.js", "kivi.File.js", "kivi.RecordTemplate.js", "kivi.AR.js", "kivi.CustomerVendor.js", "kivi.Validator.js");
 
   my $transdate = $::form->{transdate} ? DateTime->from_kivitendo($::form->{transdate}) : DateTime->today_local;
   my $first_taxchart;
diff --git a/bin/mozilla/is.pl b/bin/mozilla/is.pl
index 4f83a4e5b..293091bca 100644
--- a/bin/mozilla/is.pl
+++ b/bin/mozilla/is.pl
@@ -482,7 +482,7 @@ sub form_header {
   ), @custom_hiddens,
   map { $_.'_rate', $_.'_description', $_.'_taxnumber' } split / /, $form->{taxaccounts}];
 
-  $::request->{layout}->use_javascript(map { "${_}.js" } qw(kivi.Draft kivi.File kivi.SalesPurchase kivi.Part kivi.CustomerVendor ckeditor/ckeditor ckeditor/adapters/jquery kivi.io client_js));
+  $::request->{layout}->use_javascript(map { "${_}.js" } qw(kivi.Draft kivi.File kivi.SalesPurchase kivi.Part kivi.CustomerVendor kivi.Validator ckeditor/ckeditor ckeditor/adapters/jquery kivi.io client_js));
 
   $TMPL_VAR{payment_terms_obj} = get_payment_terms_for_invoice();
   $form->{duedate}             = $TMPL_VAR{payment_terms_obj}->calc_date(reference_date => $form->{invdate}, due_date => $form->{duedate})->to_kivitendo if $TMPL_VAR{payment_terms_obj};
diff --git a/templates/webpages/ap/form_header.html b/templates/webpages/ap/form_header.html
index 66555bdc2..d749e581e 100644
--- a/templates/webpages/ap/form_header.html
+++ b/templates/webpages/ap/form_header.html
@@ -301,7 +301,7 @@
             [% temp = "paid_"_ i %]
             <td align="center">
               [% IF( changeable ) %]
-                <input name="[% temp %]" size="11" value="[% $temp | html %]" onBlur="check_right_number_format(this);">
+                <input name="[% temp %]" size="11" data-validate="number" class="numeric" value="[% $temp | html %]">
               [% ELSE %]
                 [% $temp | html %]
                 <input type="hidden" name="[% temp %]" value="[% $temp | html %]">
diff --git a/templates/webpages/ar/form_header.html b/templates/webpages/ar/form_header.html
index a1c479d6a..d1916ecea 100644
--- a/templates/webpages/ar/form_header.html
+++ b/templates/webpages/ar/form_header.html
@@ -254,7 +254,7 @@
          </td>
          <td align=center>
   [%- IF row.changeable %]
-          <input name="paid_[% loop.count %]" size=11 value="[% row.paid ? LxERP.format_amount(row.paid, 2) : '' | html %]" onBlur="check_right_number_format(this)">
+          <input name="paid_[% loop.count %]" size=11 data-validate="number" class="numeric" value="[% row.paid ? LxERP.format_amount(row.paid, 2) : '' | html %]">
   [%- ELSE %]
          [% row.paid | html %]<input type=hidden name="paid_[% loop.count %]" value="[% row.paid ? LxERP.format_amount(row.paid, 2) : '' | html %]">
   [%- END %]
diff --git a/templates/webpages/is/_payments.html b/templates/webpages/is/_payments.html
index ce4cb8ab4..23400b583 100644
--- a/templates/webpages/is/_payments.html
+++ b/templates/webpages/is/_payments.html
@@ -72,7 +72,7 @@
      </td>
      <td align="center">
      [% IF $changeable %]
-       <input name="paid_[% i %]" size="11" value="[% LxERP.format_amount($paid, 2, 1) %]">
+       <input name="paid_[% i %]" size="11" data-validate="number" class="numeric" value="[% LxERP.format_amount($paid, 2, 1) %]">
      [% ELSE %]
        <input type="hidden" name="paid_[% i %]" value="[% LxERP.format_amount($paid, 2, 1) %]">
        [% LxERP.format_amount($paid, 2, 1) %]
@@ -112,17 +112,6 @@
      </td>
 
     </tr>
-  [% IF $changeable %]
-    <tr style='display:none'>
-     <td>
-    <script type='text/javascript'>
-     $('input[name="paid_[% i %]"]').blur(function(){ check_right_number_format(this) });
-     $('#datepaid_[% i %]').change(function(){ check_right_date_format(this) });
-    </script>
-     </td>
-    </tr>
-  [% END %]
-
 [% END # foreach %]
 
     <tr>