commit bfdc537fd1664812343a6c7ce690c716f8f6a580
Author: Andreas Rudin <andreas.rudin@revamp-it.ch>
Date:   Sun Dec 9 19:20:18 2018 +0100

    Fixt #350 Fehler p.income_accno_id does not exist
    
    Die mehrmals in RP.pm vorkommenden Zeilen
    'JOIN chart c on (p.income_accno_id = c.id)'
    und
    'JOIN chart c on (p.expense_accno_id = c.id)'
    erzeugten einen Fehler, da es in der Tabelle parts
    keine solchen Spalten gibt, sondern in taxzone_charts
    Deshalb jeweils die Zeile
    'JOIN taxzone_charts t ON (p.buchungsgruppen_id = t.id)'
    vorher eingefügt und jeweils p.income bzw. p.expense durch
    t.income bzw. t.expense ersetzt.
    Der Fehler trat auf bei 'Berichte -> Projektbuchungen'
    sowie bei der GUV und BWA mit ausgewähltem Projekt.

diff --git a/SL/RP.pm b/SL/RP.pm
index 016e268ec..ec3be2699 100644
--- a/SL/RP.pm
+++ b/SL/RP.pm
@@ -311,7 +311,8 @@ sub get_accounts {
          FROM invoice ac
          JOIN ar a ON (a.id = ac.trans_id)
          JOIN parts p ON (ac.parts_id = p.id)
-         JOIN chart c on (p.income_accno_id = c.id)
+         JOIN taxzone_charts t ON (p.buchungsgruppen_id = t.id)
+         JOIN chart c on (t.income_accno_id = c.id)
          -- use transdate from subwhere
          WHERE (c.category = 'I')
            $subwhere
@@ -332,7 +333,8 @@ sub get_accounts {
          FROM invoice ac
          JOIN ap a ON (a.id = ac.trans_id)
          JOIN parts p ON (ac.parts_id = p.id)
-         JOIN chart c on (p.expense_accno_id = c.id)
+         JOIN taxzone_charts t ON (p.buchungsgruppen_id = t.id)
+         JOIN chart c on (t.expense_accno_id = c.id)
          WHERE (c.category = 'E')
            $subwhere
            $dpt_where
@@ -374,7 +376,8 @@ sub get_accounts {
       FROM invoice ac
       JOIN ar a ON (a.id = ac.trans_id)
       JOIN parts p ON (ac.parts_id = p.id)
-      JOIN chart c on (p.income_accno_id = c.id)
+      JOIN taxzone_charts t ON (p.buchungsgruppen_id = t.id)
+      JOIN chart c on (t.income_accno_id = c.id)
       -- use transdate from subwhere
       WHERE (c.category = 'I')
         $subwhere
@@ -388,7 +391,8 @@ sub get_accounts {
       FROM invoice ac
       JOIN ap a ON (a.id = ac.trans_id)
       JOIN parts p ON (ac.parts_id = p.id)
-      JOIN chart c on (p.expense_accno_id = c.id)
+      JOIN taxzone_charts t ON (p.buchungsgruppen_id = t.id)
+      JOIN chart c on (t.expense_accno_id = c.id)
       WHERE (c.category = 'E')
         $subwhere
         $dpt_where
@@ -572,7 +576,8 @@ sub get_accounts_g {
          FROM invoice ac
          JOIN ar a ON (a.id = ac.trans_id)
          JOIN parts p ON (ac.parts_id = p.id)
-         JOIN chart c on (p.income_accno_id = c.id)
+         JOIN taxzone_charts t ON (p.buchungsgruppen_id = t.id)
+         JOIN chart c on (t.income_accno_id = c.id)
          WHERE (c.category = 'I') $prwhere $dpt_where
            AND ac.trans_id IN ( SELECT trans_id FROM acc_trans a WHERE (a.chart_link LIKE '%AR_paid%') $subwhere)
            $project
@@ -584,7 +589,8 @@ sub get_accounts_g {
          FROM invoice ac
          JOIN ap a ON (a.id = ac.trans_id)
          JOIN parts p ON (ac.parts_id = p.id)
-         JOIN chart c on (p.expense_accno_id = c.id)
+         JOIN taxzone_charts t ON (p.buchungsgruppen_id = t.id)
+         JOIN chart c on (t.expense_accno_id = c.id)
          WHERE (c.category = 'E') $prwhere $dpt_where
            AND ac.trans_id IN ( SELECT trans_id FROM acc_trans a WHERE (a.chart_link LIKE '%AP_paid%') $subwhere)
          $project
@@ -617,7 +623,8 @@ sub get_accounts_g {
         FROM invoice ac
         JOIN ar a ON (a.id = ac.trans_id)
         JOIN parts p ON (ac.parts_id = p.id)
-        JOIN chart c on (p.income_accno_id = c.id)
+        JOIN taxzone_charts t ON (p.buchungsgruppen_id = t.id)
+        JOIN chart c on (t.income_accno_id = c.id)
         WHERE (c.category = 'I')
           $prwhere
           $dpt_where
@@ -630,7 +637,8 @@ sub get_accounts_g {
         FROM invoice ac
         JOIN ap a ON (a.id = ac.trans_id)
         JOIN parts p ON (ac.parts_id = p.id)
-        JOIN chart c on (p.expense_accno_id = c.id)
+        JOIN taxzone_charts t ON (p.buchungsgruppen_id = t.id)
+        JOIN chart c on (t.expense_accno_id = c.id)
         WHERE (c.category = 'E')
           $prwhere
           $dpt_where
@@ -891,7 +899,8 @@ sub trial_balance {
       FROM invoice ac
       JOIN ar a ON (ac.trans_id = a.id)
       JOIN parts p ON (ac.parts_id = p.id)
-      JOIN chart c ON (p.income_accno_id = c.id)
+      JOIN taxzone_charts t ON (p.buchungsgruppen_id = t.id)
+      JOIN chart c ON (t.income_accno_id = c.id)
       WHERE $invwhere
         $dpt_where
         $customer_where
@@ -904,7 +913,8 @@ sub trial_balance {
       FROM invoice ac
       JOIN ap a ON (ac.trans_id = a.id)
       JOIN parts p ON (ac.parts_id = p.id)
-      JOIN chart c ON (p.expense_accno_id = c.id)
+      JOIN taxzone_charts t ON (p.buchungsgruppen_id = t.id)
+      JOIN chart c ON (t.expense_accno_id = c.id)
       WHERE $invwhere
         $dpt_where
         $customer_no_union
@@ -1017,7 +1027,8 @@ sub trial_balance {
            FROM invoice ac
            JOIN parts p ON (ac.parts_id = p.id)
            JOIN ap a ON (ac.trans_id = a.id)
-           JOIN chart c ON (p.expense_accno_id = c.id)
+           JOIN taxzone_charts t ON (p.buchungsgruppen_id = t.id)
+           JOIN chart c ON (t.expense_accno_id = c.id)
            WHERE $invwhere
              $dpt_where
              $customer_no_union
@@ -1028,7 +1039,8 @@ sub trial_balance {
            FROM invoice ac
            JOIN parts p ON (ac.parts_id = p.id)
            JOIN ar a ON (ac.trans_id = a.id)
-           JOIN chart c ON (p.income_accno_id = c.id)
+           JOIN taxzone_charts t ON (p.buchungsgruppen_id = t.id)
+           JOIN chart c ON (t.income_accno_id = c.id)
            WHERE $invwhere
              $dpt_where
              $customer_where