commit cb2b558f118bdc38203edf84556aa28db4ebd1b9
Author: Jan Büren <jan@kivitendo-premium.de>
Date:   Mon Dec 4 14:55:47 2017 +0100

    Angepasste DATEV-Testfälle für den Commit von gerade

diff --git a/t/datev/datev_format_2018.t b/t/datev/datev_format_2018.t
index 4e43b3c0b..6f86dfe5e 100644
--- a/t/datev/datev_format_2018.t
+++ b/t/datev/datev_format_2018.t
@@ -244,7 +244,7 @@ my $datev_csv3  = SL::DATEV::CSV->new(datev_lines  => $datev2->generate_datev_li
                                      );
 
 my @data_csv    = sort { $a->[0] cmp $b->[0] } @{ $datev_csv3->lines };
-cmp_deeply($data_csv[0], [ 100, 'H', 'EUR', '', '', '', '4660', '1000', 9, '1703', 'Reise März 2',
+cmp_deeply($data_csv[0], [ 100, 'S', 'EUR', '', '', '', '4660', '1000', 9, '1703', 'Reise März 2',
                      '', '', '', '', '', '', '', '', '', '', '',
                      '', '', '', '', '', '', '', '', '', '', '', '', '',
                      '', '', '', '', '', '', '', '', '', '', '',
diff --git a/t/datev/invoices.t b/t/datev/invoices.t
index b9bf80f3f..9c07058de 100644
--- a/t/datev/invoices.t
+++ b/t/datev/invoices.t
@@ -75,7 +75,6 @@ cmp_deeply \@data_datev, [
                                            'kost2'        => 'Crowd-Funding September 2017',
                                            'umsatz'       => '249.9',
                                            'waehrung'     => 'EUR',
-                                           'soll_haben_kennzeichen' => 'S',
                                          },
                                          {
                                            'belegfeld1'   => "\x{de} sales \x{a5}& inv\x{f6}ice",
@@ -87,7 +86,6 @@ cmp_deeply \@data_datev, [
                                            'kost2'        => 'Crowd-Funding September 2017',
                                            'umsatz'       => 535,
                                            'waehrung'     => 'EUR',
-                                           'soll_haben_kennzeichen' => 'S',
                                          },
                                          {
                                            'belegfeld1'   => "\x{de} sales \x{a5}& inv\x{f6}ice",
@@ -102,7 +100,6 @@ cmp_deeply \@data_datev, [
                                            'kost2'        => 'Crowd-Funding September 2017',
                                            'umsatz'       => '784.9',
                                            'waehrung'     => 'EUR',
-                                           'soll_haben_kennzeichen' => 'S',
                                          },
                                        ], "trans_id datev check ok";
 
@@ -120,7 +117,6 @@ cmp_bag $datev1->generate_datev_lines, [
                                            'kost2'        => 'Crowd-Funding September 2017',
                                            'umsatz'       => '249.9',
                                            'waehrung'     => 'EUR',
-                                           'soll_haben_kennzeichen' => 'S',
                                          },
                                          {
                                            'belegfeld1'   => "\x{de} sales \x{a5}& inv\x{f6}ice",
@@ -132,7 +128,6 @@ cmp_bag $datev1->generate_datev_lines, [
                                            'kost2'        => 'Crowd-Funding September 2017',
                                            'umsatz'       => 535,
                                            'waehrung'     => 'EUR',
-                                           'soll_haben_kennzeichen' => 'S',
                                          },
                                          {
                                            'belegfeld1'   => "\x{de} sales \x{a5}& inv\x{f6}ice",
@@ -144,7 +139,6 @@ cmp_bag $datev1->generate_datev_lines, [
                                            'kost2'        => 'Crowd-Funding September 2017',
                                            'umsatz'       => '784.9',
                                            'waehrung'     => 'EUR',
-                                           'soll_haben_kennzeichen' => 'S',
                                          },
                                        ], "trans_id datev check use_pk ok";
 
@@ -265,7 +259,6 @@ cmp_deeply $datev1->generate_datev_lines, [
                                           'konto'                  => '3400',
                                           'kost1'                  => undef,
                                           'kost2'                  => undef,
-                                          'soll_haben_kennzeichen' => 'H',
                                           'umsatz'                 => 119,
                                           'waehrung'               => 'EUR'
                                         },
@@ -277,7 +270,6 @@ cmp_deeply $datev1->generate_datev_lines, [
                                           'konto'                  => '3300',
                                           'kost1'                  => undef,
                                           'kost2'                  => undef,
-                                          'soll_haben_kennzeichen' => 'H',
                                           'umsatz'                 => 107,
                                           'waehrung'               => 'EUR'
                                         }
@@ -293,7 +285,6 @@ cmp_deeply $datev1->generate_datev_lines, [
                                           'konto'                  => '3400',
                                           'kost1'                  => undef,
                                           'kost2'                  => undef,
-                                          'soll_haben_kennzeichen' => 'H',
                                           'umsatz'                 => 119,
                                           'waehrung'               => 'EUR'
                                         },
@@ -305,7 +296,6 @@ cmp_deeply $datev1->generate_datev_lines, [
                                           'konto'                  => '3300',
                                           'kost1'                  => undef,
                                           'kost2'                  => undef,
-                                          'soll_haben_kennzeichen' => 'H',
                                           'umsatz'                 => 107,
                                           'waehrung'               => 'EUR'
                                         }